/* Crear objetos de escritorio de SciTech SNAP Graphics */
/*********************************************************/
/* Antes de ejecutar este archivo, SET LANG= debe estar */
/* establecido en el idioma correspondiente. Quiz ya  */
/* est establecido correctamente en CONFIG.SYS.       */
/* Por ejemplo:                                        */
/* SET LANG=ar_AA para rabe                           */
/* SET LANG=pt_BR para portugus de Brasil             */
/* SET LANG=zh_CN para chino simplificado              */
/* SET LANG=de_DE para alemn                          */
/* SET LANG=da_DK para dans                           */
/* SET LANG=es_ES para espaol                         */
/* SET LANG=el_GR para griego                          */
/* SET LANG=fi_FI para finlands                       */
/* SET LANG=fr_FR para francs                         */
/* SET LANG=iw_IL para hebreo                          */
/* SET LANG=it_IT para italiano                        */
/* SET LANG=ja_JP para japons                         */
/* SET LANG=ko_KR para coreano                         */
/* SET LANG=nl_NL para holands                        */
/* SET LANG=no_NO para noruego                         */
/* SET LANG=sv_SE para sueco                           */
/* SET LANG=zh_TW para chino de Taiwn                 */
/* SET LANG=en_US para ingls (valor por omisin)      */
/*******************************************************/

/******************************************
* Definir series de MRI aqu
*******************************************/

  MRI_PARAMETERS_GAMON             = 'Parmetros para GAMON (-h para uso)'
  MRI_TITLE_CONFIGURATION_PROGRAM  = 'Programa^de configuracin'
  MRI_TITLE_HARDWARE_REPORT        = 'Informe^de hardware'
  MRI_TITLE_MONITOR_UTILITY        = 'Programa de^utilidad de pantalla'
  MRI_TITLE_SCITECH_FOLDER_NAME    = 'SciTech SNAP^Graphics'
  MRI_TITLE_SCITECH_MARKETPLACE    = 'Productos^disponibles SciTech'
  MRI_TITLE_UNINSTALL              = 'Desinstalar'

/******************************************
* Define message ids from *mid*.h
*******************************************/

  MSG_CANNOT_MAKE            =   82
  MSG_INSTALL_UNSUCCESSFUL   = 1975



/* Register with REXX API extensions. */
Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs

/* get current directory - Where SNAP utilities are installed */
os2bootPath = SysSearchPath('PATH', 'os2boot')
if os2bootpath \= ''
then bootDrive = filespec('drive', os2bootPath)
else exit
snapdir=bootDrive || '\snap'

CreateObjects:

/* Create the Scitech folder on Desktop */
Class='WPFolder'
Location='<WP_DESKTOP>'
ObjectID='<SCITECH_DESKTOP>'
Title=MRI_TITLE_SCITECH_FOLDER_NAME
SETUP='ICONVIEWPOS=16 44 56 23;ALWAYSSORT=YES;OPEN=NO;DISABLETOOLBAR=1;'

Call MakeObject

/* All other objects created in Scitech folder */
Location='<SCITECH_DESKTOP>'

/* Create Shadows */
Class='WPShadow'

Title='System'
ObjectID='<SCITECH_SYSTEM>'
SETUP='SHADOWID=<WP_SYSTEM>;'
Call MakeObject

Title='readme.txt'
ObjectID='<SCITECH_README>'
SETUP='SHADOWID='snapdir'\readme.txt'
Call MakeObject

Title='snapos2.pdf'
ObjectID='<SCITECH_MANUAL>'
SETUP='SHADOWID='snapdir'\snapos2.pdf'
Call MakeObject

/* Make URLs */
Class='WPUrl'

Title=MRI_TITLE_SCITECH_MARKETPLACE
ObjectID='<SCITECH_MARKET>'
SETUP='URL=https://store.scitechsoft.com/'
Call MakeObject

/* Make Programs */
Class='WPProgram'

Title=MRI_TITLE_MONITOR_UTILITY
ObjectID='<SCITECH_GAMON>'
SETUP='EXENAME=CMD.EXE;'||,
          'STARTUPDIR='snapdir';'||,
          'PARAMETERS=/c (GAMON.EXE [' || MRI_PARAMETERS_GAMON || '] ' ||,
                  '> gamon.out & e.exe gamon.out );'||,
      'PROGTYPE=WINDOWABLEVIO;'
Call MakeObject

Title=MRI_TITLE_CONFIGURATION_PROGRAM
ObjectID='<SCITECH_GACTRL>'
SETUP='EXENAME='snapdir'\GACTRL.EXE;'||,
          'STARTUPDIR='snapdir';'||,
      'PROGTYPE=FULLSCREEN;'
Call MakeObject

Title=MRI_TITLE_HARDWARE_REPORT
ObjectID='<SCITECH_REPORT>'
SETUP='EXENAME=cmd.exe;'||,
          'STARTUPDIR='snapdir';'||,
      'PARAMETERS=/c (GAREPORT.EXE > gareport.out & start /f e.exe gareport.out);'||,
      'PROGTYPE=FULLSCREEN;'
Call MakeObject

Title=MRI_TITLE_UNINSTALL
ObjectID='<SCITECH_UNINSTAL>'
SETUP='EXENAME='snapdir'\UNINSTAL.EXE;'||,
                  'STARTUPDIR='snapdir';'||,
          'PROGTYPE=PM;'||,
          'NOAUTOCLOSE=YES;'
Call MakeObject

exit

/******************************************************
* Make a Work Place Shell object
*******************************************************/

MakeObject:
  if SysCreateObject(Class,Title,Location,'OBJECTID='ObjectID';'||,
                     'TITLE='title';'SETUP,'U')<>1,
  then Say Title || ' ' || MyGetMsg(SysGetMessage(MSG_CANNOT_MAKE))
  return

/******************************************************
* Remove SYSXXXX: from messages
*******************************************************/

MyGetMsg: Procedure

  parse arg message
  if pos('SYS', word(message, 1)) == 1
    then parse arg . message
  return message
