/* Create SciTech SNAP Graphics Desktop objects    */
/* (Modified for IT NLV by Mirco Miranda (2004/05) */
/*
Changelog:

* 31/10/2005; MMIR:
   - Called SysDestroyObject before creation of all objects.
     This fixes problem with the shadows of readme.txt and smapos2.pdf
     when I update its with the italian version (english readme.txt
     will be renamed leggimi1.txt by the wps and this is not correct)

* 05/2004; MMIR:
   - added english doc folder with original english documentation
     the italian docs will be linked (shadow) into scitech folder

* previous 
   - changelog not performed

*/


/******************************************
* Define MRI strings here
*******************************************/

  MRI_PARAMETERS_GAMON                  = 'Parameteri per GAMON (-h per l''aiuto)'
  MRI_TITLE_CHANGE_LOG                  = 'Cronologia dei^cambiamenti'
  MRI_TITLE_CONFIGURATION_PROGRAM       = 'Programma di^configurazione'
  MRI_TITLE_HARDWARE_REPORT             = 'Prospetto^hardware'
  MRI_TITLE_MONITOR_UTILITY             = 'Programma di^selezione monitor'
  MRI_TITLE_SCITECH_FOLDER_NAME         = 'SciTech SNAP^Graphics/Pro'
  MRI_TITLE_SCITECH_MARKETPLACE         = 'Sito acquisto^prodotti SciTech'
  MRI_TITLE_UNINSTALL                   = 'Disinstallazione'
  MRI_TITLE_SCITECH_ENGLISH_FOLDER_NAME = 'Documentazione^inglese'

/******************************************
* Define message ids from *mid*.h
*******************************************/

  MSG_CANNOT_MAKE            =   82
  MSG_INSTALL_UNSUCCESSFUL   = 1975



/* Register with REXX API extensions. */
Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs

/* get current directory - Where SNAP utilities are installed */

/* 
parse source one two me
snapdir = filespec('Drive', me) || filespec('Path', me)
*/

os2bootPath = SysSearchPath('PATH', 'os2boot')
if os2bootpath \= ''
then bootDrive = filespec('drive', os2bootPath)
else exit
snapdir=bootDrive || '\snap'

/* 31/10/2005; MMIR: remove existent folder */
call SysDestroyObject '<SCITECH_DESKTOP>'

CreateObjects:

/* Create the Scitech folder on Desktop */
Class='WPFolder'
Location='<WP_DESKTOP>'
ObjectID='<SCITECH_DESKTOP>'
Title=MRI_TITLE_SCITECH_FOLDER_NAME
SETUP='ICONVIEWPOS=16 44 56 23;ALWAYSSORT=YES;OPEN=NO;DISABLETOOLBAR=1;'

Call MakeObject

/* create english document folder (by MMIR) */
Location='<SCITECH_DESKTOP>'
ObjectID='<SCITECH_ENGLISH_DOC>'
Title=MRI_TITLE_SCITECH_ENGLISH_FOLDER_NAME
SETUP=''

Call MakeObject
/* !MMIR */


/* All other objects created in Scitech folder */
Location='<SCITECH_DESKTOP>'

/* Create Shadows */
Class='WPShadow'

Title='Sistema'
ObjectID='<SCITECH_SYSTEM>'
SETUP='SHADOWID=<WP_SYSTEM>;'
Call MakeObject

Title='leggimi.txt'
ObjectID='<SCITECH_README>'
SETUP='SHADOWID='snapdir'\leggimi.txt'
Call MakeObject

Title='snapos2_it.pdf'
ObjectID='<SCITECH_MANUAL>'
SETUP='SHADOWID='snapdir'\snapos2_it.pdf'
Call MakeObject

/* documentazione inglese (by MMIR) */
Location='<SCITECH_ENGLISH_DOC>'

Title='readme.txt'
ObjectID='<SCITECH_ENGLISH_README>'
SETUP='SHADOWID='snapdir'\readme.txt'
Call MakeObject

Title='snapos2.pdf'
ObjectID='<SCITECH_ENGLISH_MANUAL>'
SETUP='SHADOWID='snapdir'\snapos2.pdf'
Call MakeObject

Location='<SCITECH_DESKTOP>'
/* !MMIR */

/* Make URLs */

Class='WPUrl'
Title=MRI_TITLE_CHANGE_LOG
ObjectID='<SCITECH_CHANGES>'
SETUP='URL=http://www.scitechsoft.com/snap2_changes.txt'
Call MakeObject

Title=MRI_TITLE_SCITECH_MARKETPLACE
ObjectID='<SCITECH_MARKET>'
SETUP='URL=https://store.scitechsoft.com/'
Call MakeObject

/* Make Programs */
Class='WPProgram'

Title=MRI_TITLE_MONITOR_UTILITY
ObjectID='<SCITECH_GAMON>'
SETUP='EXENAME=CMD.EXE;'||,
          'STARTUPDIR='snapdir';'||,
          'PARAMETERS=/c (GAMON.EXE [' || MRI_PARAMETERS_GAMON || '] ' ||,
                  '> gamon.out & e.exe gamon.out );'||,
      'PROGTYPE=WINDOWABLEVIO;'
Call MakeObject

Title=MRI_TITLE_CONFIGURATION_PROGRAM
ObjectID='<SCITECH_GACTRL>'
SETUP='EXENAME='snapdir'\GACTRL.EXE;'||,
          'STARTUPDIR='snapdir';'||,
      'PROGTYPE=FULLSCREEN;'
Call MakeObject

Title=MRI_TITLE_HARDWARE_REPORT
ObjectID='<SCITECH_REPORT>'
SETUP='EXENAME=cmd.exe;'||,
          'STARTUPDIR='snapdir';'||,
      'PARAMETERS=/c (GAREPORT.EXE > gareport.out & start /f e.exe gareport.out);'||,
      'PROGTYPE=FULLSCREEN;'
Call MakeObject

Title=MRI_TITLE_UNINSTALL
ObjectID='<SCITECH_UNINSTAL>'
SETUP='EXENAME='snapdir'\UNINSTAL.EXE;'||,
                  'STARTUPDIR='snapdir';'||,
          'PROGTYPE=PM;'||,
          'NOAUTOCLOSE=YES;'
Call MakeObject

exit

/******************************************************
* Make a Work Place Shell object
*******************************************************/

MakeObject:
  if SysCreateObject(Class,Title,Location,'OBJECTID='ObjectID';'||,
                     'TITLE='title';'SETUP,'U')<>1,
  then Say Title || ' ' || MyGetMsg(SysGetMessage(MSG_CANNOT_MAKE))
  return

/******************************************************
* Remove SYSXXXX: from messages
*******************************************************/

MyGetMsg: Procedure

  parse arg message
  if pos('SYS', word(message, 1)) == 1
    then parse arg . message
  return message

