/*******************************************************/
/* Before running, SET LANG= to the correct language.  */
/* It may already be correctly set in your CONFIG.SYS. */
/* For examples:                                       */
/* SET LANG=ar_AA for Arabic / Egypt                   */
/* SET LANG=pt_BR for Portugese / Brazil               */
/* SET LANG=zh_CN for Simplified Chinese / China       */
/* SET LANG=zh_CX for Simplified Chinese GBX / China   */
/* SET LANG=de_DE for German / Germany                 */
/* SET LANG=da_DK for Danish / Denmark                 */
/* SET LANG=es_ES for Spanish / Spain                  */
/* SET LANG=el_GR for Greek / Greece                   */
/* SET LANG=fi_FI for Finnish / Finland                */
/* SET LANG=fr_FR for French / France                  */
/* SET LANG=zh_HK for Traditional Chinese / Hong Kong  */
/* SET LANG=iw_IL for Hebrew / Israel                  */
/* SET LANG=it_IT for Italian / Italy                  */
/* SET LANG=ja_JP for Japanese / Japan                 */
/* SET LANG=ko_KR for Korean / Korea                   */
/* SET LANG=nl_NL for Dutch / Netherlands              */
/* SET LANG=no_NO for Norwegian / Norway               */
/* SET LANG=sv_SE for Swedish / Sweden                 */
/* SET LANG=zh_SG for Simplified Chinese / Singapore   */
/* SET LANG=zh_TW for Traditional Chinese / Taiwan     */
/* SET LANG=en_US for English (default)                */
/*******************************************************/

call RxFuncAdd 'SysLoadFuncs' , 'REXXUTIL', 'SysLoadFuncs'
call SysLoadFuncs

/***************************************************************************
* Define Locale Mappings
*
* loc = a location which maps to multiple keys where first is more common
* Some locations are languages or nlv where not ambiguous with location.
* Table entries are sorted by location.  The algorithm depends on this!
* Some locations have more than one language/locale/table entry.
* Most common language locale is listed first.  The algorithm depends on this!
*
* key = a locale which maps to single nlv, splits into language and location
* Many locales have more than one location/table entry,
* because they have more than one location/language/nlv string.
*
* nlv = national language version which is source subdirectory
* Most nlv's support more than one locale.
* Some nlv's are no longer supported and subsequently mapped instead to EN.
****************************************************************************/

  locale_loc =               '    AA    AL    AR    AS    AT    AU    BA    BE'
  locale_key =               ' AR_AA SQ_AL ES_AR EN_AS DE_AT EN_AU SH_BA FR_BE'
  locale_nlv =               '    AR    EN    ES    EN    DE    EN    EN    FR'

  locale_loc = locale_loc || '    BE    BG    BH    BO    BR    BY    CA    CA'
  locale_key = locale_key || ' NL_BE BG_BG AR_BH ES_BO PT_BR BE_BY EN_CA FR_CA'
  locale_nlv = locale_nlv || '    NL    BG    AR    ES    BR    UK    EN    FR'

  locale_loc = locale_loc || '    CF    CH    CH    CH    CL    CN    CO    CR'
  locale_key = locale_key || ' FR_CA DE_CH FR_CH IT_CH ES_CL ZH_CN ES_CO ES_CR'
  locale_nlv = locale_nlv || '    FR    DE    FR    IT    ES    CN    ES    ES'

  locale_loc = locale_loc || '    CS    CX    CZ    DA    DE    DK    DO    DZ'
  locale_key = locale_key || ' CS_CZ ZH_CX CS_CZ DA_DK DE_DE DA_DK ES_DO AR_DZ'
  locale_nlv = locale_nlv || '    CZ    CN    CZ    DK    DE    DK    ES    AR'

  locale_loc = locale_loc || '    EC    EE    EG    EL    EN    ES    ES    ES'
  locale_key = locale_key || ' ES_EC ET_EE AR_EG EL_GR EN_US ES_ES CA_ES EU_ES'
  locale_nlv = locale_nlv || '    ES    EN    AR    GR    EN    ES    CA    ES'

  locale_loc = locale_loc || '    ET    EU    FI    FR    GB    GE    GK    GR'
  locale_key = locale_key || ' ET_EE EU_ES FI_FI FR_FR EN_GB EN_GR EL_GR EL_GR'
  locale_nlv = locale_nlv || '    EN    ES    FI    FR    UK    GE    GR    GR'

  locale_loc = locale_loc || '    GR    GT    HE    HK    HN    HR    HU    IC'
  locale_key = locale_key || ' EN_GR ES_GT IW_IL ZH_HK ES_HN HR_HR HU_HU IS_IS'
  locale_nlv = locale_nlv || '    GE    ES    HE    TW    ES    EN    HU    UK'

  locale_loc = locale_loc || '    ID    IE    IL    IN    IS    IT    IW    JA'
  locale_key = locale_key || ' IN_ID EN_IE IW_IL EN_IN IS_IS IT_IT IW_IL JA_JP'
  locale_nlv = locale_nlv || '    UK    UK    HE    UK    UK    IT    HE    JP'

  locale_loc = locale_loc || '    JO    JP    KO    KR    KW    LA    LB    LI'
  locale_key = locale_key || ' AR_JO JA_JP KO_KR KO_KR AR_KW ES_LA AR_LB DE_LI'
  locale_nlv = locale_nlv || '    AR    JP    KR    KR    AR    ES    AR    DE'

  locale_loc = locale_loc || '    LT    LU    LU    LV    MA    MK    MX    NE'
  locale_key = locale_key || ' LT_LT FR_LU DE_LU LV_LV AR_MA MK_MK ES_MX NL_NL'
  locale_nlv = locale_nlv || '    EN    FR    DE    EN    AR    EN    ES    NL'

  locale_loc = locale_loc || '    NI    NL    NO    NZ    OM    PA    PE    PK'
  locale_key = locale_key || ' ES_NI NL_NL NO_NO EN_NZ AR_OM ES_PA ES_PE EN_PK'
  locale_nlv = locale_nlv || '    ES    NL    NO    EN    AR    ES    ES    EN'

  locale_loc = locale_loc || '    PL    PO    PT    PY    QA    RO    RU    SA'
  locale_key = locale_key || ' PL_PL PT_PT PT_PT ES_PY AR_QA RO_RO RU_RU AR_SA'
  locale_nlv = locale_nlv || '    PL    PT    PT    ES    AR    EN    RU    AR'

  locale_loc = locale_loc || '    SD    SE    SF    SG    SH    SI    SK    SL'
  locale_key = locale_key || ' DE_CH SV_SE FR_CH ZH_SG SH_BA SL_SI SK_SK SL_SI'
  locale_nlv = locale_nlv || '    DE    SE    FR    CN    EN    EN    EN    EN'

  locale_loc = locale_loc || '    SP    SQ    SR    SU    SV    SW    SY    TH'
  locale_key = locale_key || ' SR_SP SQ_AL SR_SP FI_FI ES_SV SV_SE AR_SY TH_TH'
  locale_nlv = locale_nlv || '    EN    EN    EN    FI    ES    SE    AR    TH'

  locale_loc = locale_loc || '    TN    TR    TW    UA    UA    UK    US    US'
  locale_key = locale_key || ' AR_TN TR_TR ZH_TW AR_UA UK_UA EN_GB EN_US ES_US'
  locale_nlv = locale_nlv || '    AR    TR    TW    AR    UK    UK    EN    ES'

  locale_loc = locale_loc || '    UX    UY    VE    YE    ZA    ZH'
  locale_key = locale_key || ' IN_ID ES_UY ES_VE AR_YE EN_ZA ZH_CX'
  locale_nlv = locale_nlv || '    UK    ES    ES    AR    UK    CN'

parse source one two me
srcPath = filespec('Drive', me) || filespec('Path', me)
env = 'OS2ENVIRONMENT'
envlang = value('LANG',,env)
Parse Upper Var envlang locale

  /* Goal is to find an index which seem to match intent. */
  if Length( locale ) >= 5
  then do /* Check whether long form locale is supported: */
    /* remove "_euro" etc */
    locale = SubStr(locale, 1, 5)
    index = wordpos( locale, locale_key )
  end
  else index = 0

  if ((index == 0) & (Length( locale ) >= 2) )
  then do /* locale should be nlv/location/language: */
    lang = SubStr( locale, 1, 2 )
    index = wordpos( lang , locale_nlv )
    if index > 0
    then do /* It was an nlv.  Should also be a location string. */
      nlv = lang
      index = wordpos( nlv , locale_loc )
      if( nlv \= word( locale_nlv, index ) )
        /* Was an ambiguous language/location/nlv. */
        /* Must be AR/CA. Use as nlv only. */
      then index = wordpos( nlv , locale_nlv )
    end
      /* Not an nlv. */
      /* So see if it's a location or lang:   */
      /* Note that BE/IN/UA are ambiguous. */
      /* We pick the most likely meaning.     */
    else index = wordpos( lang , locale_loc )
  end
  if index == 0
    /* It was not an nlv, location, or lang. So it's unknown. */
  then index = wordpos( 'EN_US', locale_key )
  locale = word( locale_key, index )
  nlv = word( locale_nlv, index )
  say 'ENV LANG=' || envlang || ', LOCALE=' || locale || ', NLV=' || nlv
  say ''

  files = srcPath || nlv || '\*.*'
  if stream(files, 'c', 'query exists') == ''
  then nlv = 'EN' /* All unsupported nlv's map to EN */

parse upper value VALUE("PATH",,env) with "\OS2\SYSTEM" -2 BOOTDRIVE +2

if filespec('Drive', srcPath) \= strip(srcPath, 'T', '\')
  then srcDir = strip(srcPath, 'T', '\')
  else srcDir = srcPath

/* DSPINSTL decides to remove SVGADATA.PMI, save it to put it back */
'@copy ' || BOOTDRIVE || '\OS2\svgadata.pmi ' || BOOTDRIVE || '\OS2\svgadata.sdd > nul'

'@dspinstl.exe /s:' || srcDir || ' /t:' || BOOTDRIVE || ' /pd:SNAPNLV.DSC'

/* Put back the saved SVGADATA.PMI */
'@copy ' || BOOTDRIVE || '\OS2\svgadata.sdd ' || BOOTDRIVE || '\OS2\svgadata.pmi > nul'

say "You must reboot for these changes to take effect"
